"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports["default"] = _default;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _props = require("./props");

Object.keys(_props).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _props[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _props[key];
    }
  });
});

function _default(context, options, env) {
  var _options$typescript = options.typescript,
      typescript = _options$typescript === void 0 ? true : _options$typescript,
      targets = options.targets,
      presetReact = options.presetReact,
      _options$loose = options.loose,
      loose = _options$loose === void 0 ? false : _options$loose,
      _options$modules = options.modules,
      modules = _options$modules === void 0 ? 'auto' : _options$modules,
      _options$useBuiltIns = options.useBuiltIns,
      useBuiltIns = _options$useBuiltIns === void 0 ? false : _options$useBuiltIns,
      transformRuntime = options.transformRuntime;
  var isTypeScriptEnabled = typescript;
  var conf = {
    presets: [[require.resolve('@babel/preset-env'), (0, _objectSpread2["default"])({
      targets: targets,
      loose: loose,
      modules: modules,
      useBuiltIns: useBuiltIns
    }, options.env)], isTypeScriptEnabled && [require.resolve('@babel/preset-typescript')]].filter(Boolean),
    plugins: [require.resolve('@babel/plugin-syntax-dynamic-import'), // Turn on legacy decorators for TypeScript files
    isTypeScriptEnabled && [require.resolve('@babel/plugin-proposal-decorators'), {
      "legacy": true
    }], [require.resolve('@babel/plugin-proposal-class-properties'), {
      loose: true
    }], require.resolve('@babel/plugin-transform-async-to-generator'), require.resolve('@babel/plugin-proposal-object-rest-spread'), require.resolve('@babel/plugin-proposal-export-namespace-from'), require.resolve('@babel/plugin-proposal-export-default-from'), require.resolve('babel-plugin-add-module-exports'), // Polyfills the runtime needed for async/await, generators, and friends
    // https://babeljs.io/docs/en/babel-plugin-transform-runtime
    transformRuntime && [require.resolve('@babel/plugin-transform-runtime'), transformRuntime]].filter(Boolean)
  };

  if (presetReact && presetReact !== true) {
    conf.presets.push([require.resolve('@babel/preset-react'), presetReact]);
  } else if (presetReact) {
    conf.presets.push(require.resolve('@babel/preset-react'));
  }

  return conf;
}
//# sourceMappingURL=index.js.map